/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CONSTANTES

//Parametros de escala
const ALTURA_VENTANA=500;
const ESCALA_GENERAL=ALTURA_VENTANA/100;
const ANCHURA_VENTANA=160*ESCALA_GENERAL;
const ANCHURA_NAVEGADOR=window.innerWidth;
const ALTURA_NAVEGADOR=window.innerHeight;

//Parametros de animacion
const INTERVALO_REFRESCAR_PANTALLA=5;
const MAX_CAMBIO_FOTOGRAMA=250;
const MAX_VELOCIDAD=1;
const MAX_DOWN_TIME=50;


//Url imagenes
//Remoto
//000webhost
//const URL_IMAGENES="http://vands.net78.net/django/imagenes/";
//alwaysdata
const URL_IMAGENES="../../../site_media/resources/imagenes/";
//Local
//const URL_IMAGENES="C:/Users/Carlos/Documents/Universidad/Proyecto/Pruebas/django/vands/imagenes/";

//Estados del menu
const MENU_INACTIVO=0;
const DESPLEGAR_MENU=1;
const REPLEGAR_MENU=2;

const MENU_MARGIN=100;
const MAX_MENU_HIGHT=25;

//Grid
const GRID_COLUMNS=12;
const GRID_ROWS=10;
const TAM_GRID_SQUARE_X=ANCHURA_VENTANA/GRID_COLUMNS;
const TAM_GRID_SQUARE_Y=ALTURA_VENTANA/GRID_ROWS;

//Fadein, fadeout
const FADE_SPEED=0.05;

//Tags
//Objetos
const TAG_GUITAR=0;
const TAG_AMP=1;
const TAG_PHONE=2;
//Dialogo
const TAG_BAND_REQUEST=0;
const TAG_BORRAR_HORARIO=1;
const TAG_NUEVO_HORARIO=2;
const TAG_SELECCIONAR_BANDA=3;
const TAG_CONCERT_REQUEST=4;
//Escenario
const TAG_ROOM=0;
const TAG_BANDS=1;
const TAG_TIENDA_INSTRUMENTOS=2;
//Alineacion texto
const AL_IZQ=0;
const AL_DER=1;
const AL_CEN=2;

//DECLARACION DE CLASES

//Clase boton
//url: nombre de las imagenes del boton
//x: coordenada x
//y: coordenada y
//w: anchura del boton
//h: altura del boton
function Boton(url,x,y,w,h){
    this.image=new Image(); //imagen para inactividad
    this.image.src=URL_IMAGENES+"interface/"+url+".png";
    this.over_image=new Image(); //imagen cuando el raton esta encima
    this.over_image.src=URL_IMAGENES+"interface/"+url+"2.png";
	this.x=x;
	this.y=y;
	this.w=w;
	this.h=h;
	this.apuntado=0; //booleano de si el boton esta siendo apuntado con el raton o no
	
	this.destacar=function(x,y){
		this.apuntado=(x>=this.x && x<=this.x+this.w && y>=this.y && y<=this.y+this.h);
	}
}

//Menu emergente
//w: anchura de los botones
//h: altura de los botones
//s: escenario en el que nos encontramos
function Menu(w,h,s){
    this.botones=new Array(3); //coordenadas de los botones
    this.y=0; //coordenada y del menu
    this.estado=0; //estado del menu
	this.boton_apuntado=-1; //boton apuntado del menu

	var coordenadas=repartir_elementos(ANCHURA_VENTANA/2,50,this.botones.length,99,w,h,20);
	if(s==TAG_ROOM){
		this.botones[0]=new Boton("boton_bandas",coordenadas[0][0],this.y,w,h); //boton de bandas
		this.botones[1]=new Boton("boton_tiendainstrumentos",coordenadas[1][0],this.y,w,h); //boton de tienda de instrumentos
		
	}else if(s==TAG_BANDS){
		this.botones[0]=new Boton("boton_habitacion",coordenadas[0][0],this.y,w,h); //boton de habitacion
		this.botones[1]=new Boton("boton_tiendainstrumentos",coordenadas[1][0],this.y,w,h); //boton de tienda de instrumentos
	}else if(s==TAG_TIENDA_INSTRUMENTOS){
		this.botones[0]=new Boton("boton_habitacion",coordenadas[0][0],this.y,w,h); //boton de habitacion
		this.botones[1]=new Boton("boton_bandas",coordenadas[1][0],this.y,w,h); //boton de bandas
	}
		
	this.botones[2]=new Boton("boton_logout",coordenadas[2][0],this.y,w,h); //boton de logout
	
	//metodo para destacar botones apuntados
	//x: coordenada x del raton
	//y: coordenada y del raton
	this.destacar_botones=function(x,y){
		this.boton_apuntado=-1;
		var i;
		for(i=0;i<this.botones.length && this.boton_apuntado==-1;i++){
			var x1=this.botones[i].x;
			var y1=this.y;
			var x2=x1+this.botones[i].w;
			var y2=y1+this.botones[i].h;

			if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
					this.boton_apuntado=i;
		}
	}
}

//Una clase que guarda la distribucion de elementos en un dialogo, orientado a mostrar paginas de elementos
//x: coordenada x del chooser
//y: coordenada y del chooser
//w: anchura del chooser
//h: altura del chooser
//tag: etiqueta del chooser
function Chooser(x,y,w,h,tag){
	this.tag=tag; //etiqueta
	if(tag!=-1){
		this.x=x; //coordenada x del dialogo
		this.y=y; //coorenada y del dialogo
		this.w=w; //anchura del dialogo
		this.h=h; //altura del dialogo
		this.alpha=0.0; //transparencia del dialogo
		this.margen=25; //Margen entre los elementos y el borde del dialogo
		this.opcion_x=new Array(); //coordenadas x de los elementos
		this.opcion_y=y+this.margen; //coordenadas y de los elementos
		this.opcion_apuntada=-1; //opcion apuntada por el raton
		this.opcion_w=(w-(this.margen*4))/3; //anchura de los elementos
		this.opcion_h=h-(this.margen*2); //altura de los elementos
	
		var i=0;
		var n=escenario.objetos[tag].length-i;
		var tam=(this.opcion_w*n)+(this.margen*(n-1));
		var ox=x+175-(tam/2);
		
		for(j=i;j<n;j++){
			this.opcion_x[j-i]=ox;
			ox+=this.opcion_w+this.margen;
		}
	}
}

//Una clase que guarda la distribucion de elementos en un dialogo, orientado a deslizar una lista de elementos
//x: coordenada x del chooser
//y: coordenada y del chooser
//w: anchura del chooser
//h: altura del chooser
//tag: etiqueta del chooser
function Slide_chooser(x,y,w,h,m,tag){
	this.tag=tag; //etiqueta
	if(tag!=-1){
		this.x=x; //coordenada x del dialogo
		this.y=y; //coorenada y del dialogo
		this.w=w; //anchura del dialogo
		this.h=h; //altura del dialogo
		this.alpha=0.0; //transparencia del dialogo
		this.margen=m; //Margen entre los elementos y el borde del dialogo
		this.opcion_seleccionada=0; //opcion seleccionada
		this.opcion_apuntada=-1; //opcion apuntada por el raton
		
		this.trozo_izquierda=0;
		this.trozo_derecha=0;
		
		this.coordenadas=new Array(2);
		this.coordenadas[0]=x+m;
		this.coordenadas[1]=x+w-m;
		this.image_x=new Array(2);
		this.image_x[0]=0;
		this.image_x[1]=0;
		this.image_w=new Array(2);
		this.image_w[0]=0;
		this.image_w[1]=0;
		this.lienzo_w=new Array(2);
		this.lienzo_w[0]=0;
		this.lienzo_w[1]=0;
		this.lienzo_h=h-(m*2); //altura de los elementos
		this.down_x=new Array(2);
		this.down_x[0]=this.coordenadas[0];
		this.down_x[1]=this.coordenadas[1];
		this.lienzo_x=new Array(2);
		this.lienzo_x[0]=this.coordenadas[0];
		this.lienzo_x[1]=this.coordenadas[1];
		this.lienzo_y=y+m;
		
		this.pasar_elemento_alante=function(){
			
			//El elemento de la derecha pasa a ser el de la izquierda
			this.coordenadas[0]=this.coordenadas[1];
			this.down_x[0]=this.down_x[1];
			
			//Inicializamos las nuevas coordenadas del elemento de la derecha
			this.coordenadas[1]+=this.w-2*this.margen;
			this.down_x[1]+=this.w-2*this.margen;
			
			this.opcion_seleccionada++;
		}
		
		this.pasar_elemento_atras=function(){
			
			//El elemento de la izquierda pasa a ser el de la derecha
			this.coordenadas[1]=this.coordenadas[0];
			this.down_x[1]=this.down_x[0];
			
			//Inicializamos las nuevas coordenadas del elemento de la izquierda
			this.coordenadas[0]-=this.w-2*this.margen;
			this.down_x[0]-=this.w-2*this.margen;
			
			this.opcion_seleccionada--;
		}
	}
}

//Clase texto, para distribuir uniformemente el texto en funcion de los parametros
//texto: texto a distribuir
//x: x central
//y: y central
//w: w: anchura del cuadro de texto
//m_y: margen entre lineas
//al: alineacion del texto
function Texto(texto,x,y,w,m_y,al){
	var separadas=separar_palabras(texto);
	this.repartidas=repartir_texto(separadas,w); //texto descompuesto en lineas
	this.coordenadas=new Array(this.repartidas.length); //coordenadas de cada linea
	
	var i;
	var y_linea=y-(this.repartidas.length*7.5);
	
	for(i=0;i<this.repartidas.length;i++){ 
		this.coordenadas[i]=new Array(2);
		if(al==AL_IZQ){
			this.coordenadas[i][0]=x-w/2;
		}else if(al==AL_DER){
			this.coordenadas[i][0]=x+w/2-contexto.measureText(this.repartidas[i]).width;
		}else if(al==AL_CEN){
			var linea_w=contexto.measureText(this.repartidas[i]).width;
			this.coordenadas[i][0]=x-linea_w/2;
		}
		this.coordenadas[i][1]=y_linea;
		y_linea+=m_y;
	}

	//metodo para dibujar el texto
	//x: si es menor o igual a 0, dibuja en las coordenadas de la clase. Si es mayor, dibuja en x
	//y: si es menor o igual a 0, dibuja en las coordenadas de la clase. Si es mayor, dibuja en y
	this.dibujar=function(x,y){
		var x_aux=x,y_aux=y;
		for(i=0;i<this.repartidas.length;i++){
			if(x<=0) x_aux=this.coordenadas[i][0];
			if(y<=0) y_aux=this.coordenadas[i][1];			
			contexto.fillText(this.repartidas[i], x_aux, y_aux);
			y_aux+=25;
		}
	}
	
	//Devuelve todas las lineas en una unica cadena
	this.obtener_texto=function(){
		var entero="";
		for(i=0;i<this.repartidas.length;i++){
			entero+=this.repartidas[i];
		}
		return entero;
	}
}

//Rejilla que determina que parte del escenario repintar
function Grid (){	
	this.celdas=new Array(GRID_ROWS); //Celdas que pueden valer 0 (no se pintan) o 1(se pintan)
	
	var i,j;
	for(i=0;i<GRID_ROWS;i++){
		this.celdas[i]=new Array(GRID_COLUMNS);
		for(j=0;j<GRID_COLUMNS;j++)
			this.celdas[i][j]=1;
	}
	
	this.clean_grid=function(c1,r1,c2,r2){
		var i,j;
		for(i=r1;i<=r2;i++)
			for(j=c1;j<=c2;j++)
				this.celdas[i][j]=0;
	}

	this.mark_grid=function(c1,r1,c2,r2){
		var i,j;		
		for(i=r1;i<=r2;i++)
			for(j=c1;j<=c2;j++)
				this.celdas[i][j]=1;
	}

	this.clean_grid_area=function(x1,y1,x2,y2){
		var c1=Math.floor(x1/TAM_GRID_SQUARE_X);
		var c2=Math.floor(x2/TAM_GRID_SQUARE_X);
		var r1=Math.floor(y1/TAM_GRID_SQUARE_Y);
		var r2=Math.floor(y2/TAM_GRID_SQUARE_Y);
			
		this.clean_grid(c1,r1,c2,r2);
	}

	this.mark_grid_area=function(x1,y1,x2,y2){
		var c1=Math.floor(x1/TAM_GRID_SQUARE_X);
		var c2=Math.floor(x2/TAM_GRID_SQUARE_X);
		var r1=Math.floor(y1/TAM_GRID_SQUARE_Y);
		var r2=Math.floor(y2/TAM_GRID_SQUARE_Y);
		
		this.mark_grid(c1,r1,c2,r2);
	}
}

//DECLARACION DE METODOS

//Funcion que distribuye uniformemente una serie de elementos en el espacio 2D
//x: x central
//y: y central
//n: numero total de elementos
//c: numero de columnas (numero de elementos por fila)
//w: anchura de cada elemento
//h: altura de cada elemento
//m: margen entre elementos

//Devuelve: un vector de pares de coordenadas x e y
function repartir_elementos(x,y,n,c,w,h,m){
	var coordenadas=new Array(n);	
	var n_filas=Math.floor(n/c)+(n%c!=0);
	var tam_columna=n_filas*h+(n_filas-1)*m;
	var y_fila=y-tam_columna/2;
	
	var i=0;
	while(i<n){
		var tanda=n-i;
		if(tanda>3)tanda=3;
		var tam_fila=tanda*w+(tanda-1)*m;
		var x_fila=x-tam_fila/2;
		for(j=0;j<tanda;j++){
			coordenadas[i+j]=new Array(2);
			coordenadas[i+j][0]=x_fila;
			coordenadas[i+j][1]=y_fila;
			x_fila+=w+m;
		}
		y_fila+=h+m;
		i+=3;
	}
	
	return coordenadas;
}

//Separa las palabras de una linea atendiendo a los espacios
//texto: texto a separar en palabras

//Devuelve: un vector de palabras separadas
function separar_palabras(texto){
	var separadas=new Array();
	var i;
	var palabra="";
	for(i=0;i<texto.length;i++){
		if(texto[i]!=" "){
			palabra=palabra+texto[i];
		}else{
			separadas[separadas.length]=palabra;
			palabra="";
		}
	}
	separadas[separadas.length]=palabra;
	
	return separadas;
}

//Reparte texto en lineas segun una anchura limite
//palabras: vector de palabras a repartir en lineas
//w: anchura limite del cuadro de texto

//Devuelve: un vector de lineas
function repartir_texto(palabras,w){
	var i=0;
	var lineas=new Array();
	
	while(i<palabras.length){
		var nueva_linea=palabras[i];
		i++;
		while(i<palabras.length && contexto.measureText(nueva_linea+" "+palabras[i]).width<w){
			nueva_linea=nueva_linea+" "+palabras[i];
			i++;
		}
		lineas[lineas.length]=nueva_linea;
	}
	
	return lineas;
}

//Obtiene la posicion relativa de un punto respecto de una recta
//x0: coordenada x del primer punto de la recta
//y0: coordenada y del primer punto de la recta
//x1: coordenada x del segundo punto de la recta
//y1: coordenada y del segundo punto de la recta
//x2: coordenada x del punto
//y2: coordenada y del punto

//Devuelve: 0 si esta a la izquierda, 1 si esta a la derecha
function posicion_relativa(x0,y0,x1,y1,x2,y2){
	
	var d=(y2-y1)*x0+(x1-x2)*y0+(x2*y1-y2*x1);
	
	return d<=0;
}

//Adapta la coordenada x en funcion del explorador
//evento: objeto evento que contiene la coordenada x

//Devuelve: la coordenada adaptada o -1 si hay algun error
function adaptar_x_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerX-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetX-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;        
    }
    
    else return -1; //Error    
}

//Adapta la coordenada y en funcion del explorador
//evento: objeto evento que contiene la coordenada y

//Devuelve: la coordenada adaptada o -1 si hay algun error
function adaptar_y_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerY-20;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetY-20;        
    }
    
    else return -1; //Error    
}

//Redirecciona la pagina a una url indicada
//url: la nueva url
function redireccionar(url){location.href=url;}



//Dibuja un rectangulo redondeado
//x: coordenada x
//y: coordenada y
//width: anchura del rectangulo
//height: altura del rectangulo
//radius: radio del borde del rectangulo
function roundRect(x, y, width, height, radius) {
    contexto.beginPath();
    contexto.moveTo(x + radius, y);
    contexto.lineTo(x + width - radius, y);
    contexto.arc(x+width-radius, y+radius, radius, -Math.PI/2, Math.PI/2, false);
    contexto.lineTo(x + radius, y + height);
    contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    contexto.closePath();
    contexto.fill();
}

//Dibuja el marco de la barra
//x: coordenada x
//y: coordenada y
//width: anchura del marco
//height: altura del marco
//radius: radio del borde del marco
function progressLayerRect(x, y, width, height, radius) {
    contexto.save();
    // Define the shadows
    contexto.shadowOffsetX = 2;
    contexto.shadowOffsetY = 2;
    contexto.shadowBlur = 5;
    contexto.shadowColor = '#666';
 
     // first grey layer
    contexto.fillStyle = 'rgba(189,189,189,1)';
    roundRect(x, y, width, height, radius);
 
    // second layer with gradient
    // remove the shadow
    contexto.shadowColor = 'rgba(0,0,0,0)';
    var lingrad = contexto.createLinearGradient(0,y+height,0,0);
    lingrad.addColorStop(0, 'rgba(255,255,255, 0.1)');
    lingrad.addColorStop(0.4, 'rgba(255,255,255, 0.7)');
    lingrad.addColorStop(1, 'rgba(255,255,255,0.4)');
    contexto.fillStyle = lingrad;
    roundRect(x, y, width, height, radius);
 
    contexto.restore();
}

//Dibuja la barra de progreso
//x: coordenada x
//y: coordenada y
//width: anchura del progreso de la barra
//height: altura de la barra
//radius: radio del borde de la barra
//max: anchura maxima de la barra
function progressBarRect(x, y, width, height, radius, max) {
    contexto.save();
	
	// Blue gradient for progress bar
	var progress_lingrad = contexto.createLinearGradient(0,250,0,0);
	progress_lingrad.addColorStop(0, '#4DF3A4');
	progress_lingrad.addColorStop(0.4, '#ADFFD9');
	progress_lingrad.addColorStop(1, '#9EFFD1');
	
    // deplacement for chord drawing
    var offset = 0;
    contexto.beginPath();
    if (width<radius) {
        offset = radius - Math.sqrt(Math.pow(radius,2)-Math.pow((radius-width),2));
        // Left angle
        var left_angle = Math.acos((radius - width) / radius);
        contexto.moveTo(x + width, y+offset);
        contexto.lineTo(x + width, y+height-offset);
        contexto.arc(x + radius, y + radius, radius, Math.PI - left_angle, Math.PI + left_angle, false);
    }
    else if (width+radius>max) {
        offset = radius - Math.sqrt(Math.pow(radius,2)-Math.pow((radius - (max-width)),2));
        // Right angle
        var right_angle = Math.acos((radius - (max-width)) / radius);
        contexto.moveTo(x + radius, y);
        contexto.lineTo(x + width, y);
        contexto.arc(x+max-radius, y + radius, radius, -Math.PI/2, -right_angle, false);
        contexto.lineTo(x + width, y+height-offset);
        contexto.arc(x+max-radius, y + radius, radius, right_angle, Math.PI/2, false);
        contexto.lineTo(x + radius, y + height);
        contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    }
    else {
        contexto.moveTo(x + radius, y);
        contexto.lineTo(x + width, y);
        contexto.lineTo(x + width, y + height);
        contexto.lineTo(x + radius, y + height);
        contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    }
    contexto.closePath();
    contexto.fillStyle = progress_lingrad;
    contexto.fill();
	
	// texto
    var text = Math.floor(width/max*100)+"%";
    var text_width = contexto.measureText(text).width;
    var text_x = x+width-text_width-radius/2;
    if (width<=radius+text_width) {
        text_x = x+radius/2;
    }
		
    contexto.fillStyle = "#FFFFFF"; // Color del texto
    contexto.font = "bold 20px Comic Sans"; // Tamano y estilo de la fuente
    contexto.fillText(text, text_x, y+22);
	
    contexto.restore();
}

//Dibuja la barra de progreso en su conjunto
//progreso: porecentaje de progreso completado
function draw_progressbar(progreso){
	if(progreso>100) progreso=100;	
	contexto.save();
	var gradiente = contexto.createRadialGradient(ANCHURA_VENTANA/2, ALTURA_VENTANA/2, 20, ANCHURA_VENTANA/2, ALTURA_VENTANA/2, 200);
    gradiente.addColorStop(0, "#8ED6FF");
    gradiente.addColorStop(1, "#004CB3");
    contexto.fillStyle = gradiente;
    contexto.fill();
	contexto.beginPath();
	contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
	contexto.closePath();
	contexto.fill();
	contexto.restore();
	var initial_x=(ANCHURA_VENTANA/2)-150;
	var initial_y=(ALTURA_VENTANA/2)-25;
	progressLayerRect(initial_x, initial_y, 300, 50, 25);
	progressBarRect(initial_x, initial_y, (3*progreso), 50, 25, 300);
}

//Redondea mediante desplazamiento de bits
//n: numero a redondear

//Devuelve: el nuero redondeado
function myround(n){
	return (0.5 + n) | 0;
}
