/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function dibujar_fondo(){
	//Drawing the background according with the grid
	var i,j;
	for(i=0;i<GRID_ROWS;i++){
		for(j=0;j<GRID_COLUMNS;j++){
			if(grid.celdas[i][j]==1){
				contexto.drawImage(escenario.fondo_img, myround(tam_image_square_x*j), myround(tam_image_square_y*i), 
								tam_image_square_x, tam_image_square_y,
								myround(TAM_GRID_SQUARE_X*j), myround(TAM_GRID_SQUARE_Y*i), 
								myround(TAM_GRID_SQUARE_X), myround(TAM_GRID_SQUARE_Y));
			}
		}
	}
}

function dibujar_rastro(){
	
	if(jugador.direccion_x!=0 || jugador.direccion_y!=0 || jugador.rastro_alpha<1.0){ //Se esta moviendo o la nube no ha terminado de desaparecer
		contexto.save();
		jugador.rastro_alpha-=0.01;
		if(jugador.rastro_alpha<=0){
			jugador.xrastro=jugador.getX()-12;
			jugador.yrastro=jugador.getY()-25;
			
			jugador.rastro_alpha=1.0;
		}

		if((jugador.direccion_x!=0 || jugador.direccion_y!=0) || jugador.rastro_alpha<1.0){
			contexto.globalAlpha = jugador.rastro_alpha;
			contexto.drawImage(jugador.rastro_img, jugador.xrastro, jugador.yrastro, jugador.rastro_tam, jugador.rastro_tam); //pintamos el fondo del escenario
		}
		contexto.restore(); //restauramos el valor de la opacidad		
	}
}

function dibujar_depurar(){

	//Mostramos las areas de movimiento
	var i,j;
	contexto.strokeStyle = '#99F'; // Color
	
	//Eje X	
	for(i=0;i<escenario.area.length-1;i++){
		contexto.beginPath();
		contexto.moveTo(escenario.area[i][0],escenario.area[i][1]);
		contexto.lineTo(escenario.area[i+1][0],escenario.area[i][1]);
		contexto.closePath();
		contexto.stroke();
	}
	
	contexto.strokeStyle = '#F99'; // Color
	
	//Eje y	
	for(i=0;i<escenario.area.length;i++){
		contexto.beginPath();
		contexto.moveTo(escenario.area[i][0],escenario.area[i][1]);
		contexto.lineTo(escenario.area[i][0],ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
	
	//Mostramos el borde de la imagen del personaje
	
	contexto.strokeStyle = '#9F9'; // Color
	
	contexto.beginPath();
	contexto.rect(jugador.x, jugador.y, jugador.cuerpo_width, jugador.cuerpo_height);
	contexto.closePath();
	contexto.stroke();
	
	//Mostramos la trayectria del personaje
	
	contexto.strokeStyle = '#FF9'; // Color
	contexto.beginPath();
	contexto.moveTo(jugador.getX(),jugador.getY());
	contexto.lineTo(ruta.getX(),ruta.getY());
	contexto.closePath();
	contexto.stroke();
	
	for(i=ruta.n_control;i<ruta.xcontrol.length-1;i++){
		contexto.beginPath();
		contexto.moveTo(ruta.xcontrol[i],ruta.ycontrol[i]);
		contexto.lineTo(ruta.xcontrol[i+1],ruta.ycontrol[i+1]);
		contexto.closePath();
		contexto.stroke();
	}
	
	//Mostramos el borde de los objetos	
	
	contexto.strokeStyle = '#9FF'; // Color
	for(i=0;i<escenario.objetos.length;i++){
		for(j=0;j<escenario.objetos[i].length;j++){
			contexto.beginPath();
			contexto.rect(escenario.objetos[i][j].x, escenario.objetos[i][j].y, escenario.objetos[i][j].width, escenario.objetos[i][j].height);
			contexto.closePath();
			contexto.stroke();
		}
	}
	
	//Mostramos el grid
	contexto.strokeStyle = '#F0F'; // Color
	for(i=0;i<GRID_ROWS;i++){
		contexto.beginPath();
		contexto.moveTo(0,TAM_GRID_SQUARE_Y*i);
		contexto.lineTo(ANCHURA_VENTANA,TAM_GRID_SQUARE_Y*i);
		contexto.closePath();
		contexto.stroke();
	}
	
	for(i=0;i<GRID_COLUMNS;i++){
		contexto.beginPath();
		contexto.moveTo(TAM_GRID_SQUARE_X*i,0);
		contexto.lineTo(TAM_GRID_SQUARE_X*i,ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
			
	
	//Mostramos el area y la direccion del personaje
	document.formulario.texto_area.value = "area: "+area_actual;
	document.formulario.texto_direccion.value = "dir_x: "+jugador.direccion_x+" dir_y: "+jugador.direccion_y;
	//Mostramos las coordenadas actuales del personaje
	document.formulario.texto_xpos.value = "xpos: "+jugador.getX();
	document.formulario.texto_ypos.value = "ypos: "+jugador.getY();
	//Mostramos las coordenadas destino del personaje
	document.formulario.texto_xdest.value = "xdest: "+ruta.getX();
	document.formulario.texto_ydest.value = "ydest: "+ruta.getY();	
}

function dibujar_jugador(){
	contexto.drawImage(jugador.cara_img, jugador.getXCara(),jugador.getYCara(),jugador.cara_w*jugador.escala,jugador.cara_h*jugador.escala);
	contexto.drawImage(jugador.sombra_img, jugador.getXSombra(),jugador.getYSombra(),jugador.wsombra*jugador.escala,jugador.hsombra*jugador.escala);
	contexto.drawImage(jugador.cuerpo_img[fotograma], myround(jugador.x), myround(jugador.y),myround(jugador.cuerpo_width*jugador.escala),myround(jugador.cuerpo_height*jugador.escala));
}

function dibujar_objetos_detras(){
	var i,j;
	for(i=0;i<escenario.objetos.length;i++){
		if(escenario.objetos[i].length>0){
			var indice;
			if(i==TAG_GUITAR)
				indice=escenario.guitarra_activa;
			else
				indice=0;
			if(!jugador_detras_objeto(escenario.objetos[i][indice])){
				contexto.save();
				if(escenario.objetos[i][indice].dragged)
					contexto.globalAlpha=0.75;
				contexto.drawImage(escenario.objetos[i][indice].objeto_img,
					escenario.objetos[i][indice].x, escenario.objetos[i][indice].y,
					escenario.objetos[i][indice].width*escenario.objetos[i][indice].escala,
					escenario.objetos[i][indice].height*escenario.objetos[i][indice].escala);
				contexto.restore();
				//contexto.drawImage(escenario.objetos[i][indice].sombra_img,
					//escenario.objetos[i][indice].getXSombra(), escenario.objetos[i][indice].getYSombra(),
					//escenario.objetos[i][indice].wsombra*escenario.objetos[i][indice].escala,
					//escenario.objetos[i][indice].hsombra*escenario.objetos[i][indice].escala);
				
			}
		}
	}
}

function dibujar_objetos_delante(){
	var i,j;
	for(i=0;i<escenario.objetos.length;i++){
		if(escenario.objetos[i].length>0){
			var indice;
			if(i==TAG_GUITAR)
				indice=escenario.guitarra_activa;
			else
				indice=0;
			if(jugador_detras_objeto(escenario.objetos[i][indice])){
				contexto.save();
				if(escenario.objetos[i][indice].dragged )
					contexto.globalAlpha=0.75;
				contexto.drawImage(escenario.objetos[i][indice].objeto_img,
					escenario.objetos[i][indice].x, escenario.objetos[i][indice].y,
					escenario.objetos[i][indice].width*escenario.objetos[i][indice].escala,
					escenario.objetos[i][indice].height*escenario.objetos[i][indice].escala);
					contexto.restore();
				}
		}
	}
}

function dibujar_bocadillos(){
    var i;
    for(i=0;i<bocadillos.length;i++){
        if(bocadillos[i].estado==ABRIR_BOCADILLO){
            fadein_bocadillo(bocadillos[i]);
        }else if(bocadillos[i].estado==CERRAR_BOCADILLO){
            fadeout_bocadillo(bocadillos[i]);
        }
    }
        
}

function fadein_bocadillo(bocadillo){
	
		contexto.save();
        if(bocadillo.bocadillo_alpha<1.0){
                bocadillo.bocadillo_alpha+=0.01;
        }
            
        dibujar_bocadillo(bocadillo);
	
		contexto.restore(); //restauramos el valor de la opacidad
}

function fadeout_bocadillo(bocadillo){
	
	contexto.save();		
    if(bocadillo.bocadillo_alpha>0){
            bocadillo.bocadillo_alpha-=0.01;
            if(bocadillo.bocadillo_alpha<=0.0)
                bocadillo.bocadillo_alpha=0.0;
            
            dibujar_bocadillo(bocadillo);
            
	}else{
		bocadillo.estado=0;
	}
        
    contexto.restore(); //restauramos el valor de la opacidad
}

function dibujar_bocadillo(bocadillo){

    contexto.globalAlpha = bocadillo.bocadillo_alpha;
    contexto.drawImage(bocadillo.bocadillo_img, bocadillo.x, bocadillo.y, bocadillo.width, bocadillo.height);	
    //contexto.fillStyle = "#000000"; // Color del texto
    //contexto.textBaseline = "top"; // Linea base del texto
    //contexto.font = "bold 18px Comic Sans"; // Tamano y estilo de la fuente
    //contexto.fillText(bocadillo.texto, bocadillo.x+bocadillo.width/3, bocadillo.y+bocadillo.height/3); // Pintamos el texto.
    if(cerrar_destacado==bocadillo.id)
            contexto.drawImage(bocadillo.cerrar_img[1], bocadillo.cerrar_x, bocadillo.cerrar_y, bocadillo.cerrar_width, bocadillo.cerrar_height); //Pintamos el boton de cerrar
    else
            contexto.drawImage(bocadillo.cerrar_img[0], bocadillo.cerrar_x, bocadillo.cerrar_y, bocadillo.cerrar_width, bocadillo.cerrar_height); //Pintamos el boton de cerrar
}

function dibujar_menu(){
    
    if(menu.estado==DESPLEGAR_MENU || menu.estado==REPLEGAR_MENU){        
        var i;
        for(i=0;i<menu.botones.length;i++){
			if(i==menu.boton_apuntado)
				contexto.drawImage(menu.botones[i].over_image, menu.botones[i].x, menu.y, menu.botones[i].w, menu.botones[i].h);
			else
				contexto.drawImage(menu.botones[i].image, menu.botones[i].x, menu.y, menu.botones[i].w, menu.botones[i].h);
        }
	}
}

function draw_fadein(){
	if(fadein_alpha>0.0){
		contexto.save();
		contexto.globalAlpha=fadein_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadein_alpha-=FADE_SPEED;
		contexto.restore();
		if(fadein_alpha<=0.0){
			contexto.drawImage(escenario.fondo_img, 0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
			grid.clean_grid(0,0,2,GRID_ROWS-1);
			grid.clean_grid(10,0,GRID_COLUMNS-1,GRID_ROWS-1);
			desbloquear();
		}
	}
}

function draw_fadeout(){
	if(fadeout_alpha<1.0){
		contexto.save();
		contexto.globalAlpha=fadeout_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadeout_alpha+=FADE_SPEED;
		contexto.restore();
		if(fadeout_alpha>=1.0){
			contexto.globalAlpha=0.0;
			redireccionar(url_redireccionar);
		}
	}
}

function dibujar_chooser(){
	if(chooser.tag!=-1){
		contexto.save();
		
		//Definimos las sombras
		contexto.shadowOffsetX = 5;
		contexto.shadowOffsetY = 5;
		contexto.shadowBlur = 5;
		contexto.shadowColor = '#666';
		
		//Dibujamos el marco
		if(chooser.alpha<1.0){
			contexto.globalAlpha=chooser.alpha;
			chooser.alpha+=0.1;
		}
		var gradiente = contexto.createRadialGradient(chooser.x+chooser.w/2, chooser.y+chooser.h/2, 20, chooser.x+chooser.w/2, chooser.y+chooser.h/2, 200);
		gradiente.addColorStop(0, "#8ED6FF");
		gradiente.addColorStop(1, "#004CB3");
		contexto.fillStyle = gradiente;
		contexto.beginPath();
		contexto.rect(chooser.x, chooser.y, chooser.w, chooser.h);
		contexto.closePath();
		contexto.fill();
		
		//Dibujamos los objetos a seleccionar
		contexto.shadowOffsetY = 2;
		var y=chooser.y+chooser.margen;
		
		for(i=0;i<chooser.opcion_x.length;i++){
			contexto.fillStyle = "#FFFFFF";
			contexto.beginPath();
			contexto.rect(chooser.opcion_x[i], y, chooser.opcion_w, chooser.opcion_h);
			contexto.closePath();
			contexto.fill();
			
			var ow,oh;
			if(escenario.objetos[chooser.tag][i].width<escenario.objetos[chooser.tag][i].height){
				var rel=escenario.objetos[chooser.tag][i].width/escenario.objetos[chooser.tag][i].height;
				ow=chooser.opcion_h*rel;
				oh=chooser.opcion_h;
			}else{
				var rel=escenario.objetos[chooser.tag][i].height/escenario.objetos[chooser.tag][i].width;
				ow=chooser.opcion_w;
				oh=chooser.opcion_w*rel;
			}
			var ox=chooser.opcion_x[i]+chooser.opcion_w/2-ow/2;			
			var oy=chooser.opcion_y+chooser.opcion_h/2-oh/2;
			
			contexto.drawImage(escenario.objetos[chooser.tag][i].objeto_img,ox,oy,ow,oh);
			
			if(i==escenario.guitarra_activa)
				contexto.strokeStyle = "#00FF00";
			else if(i==chooser.opcion_apuntada)
				contexto.strokeStyle = "#FFFF00";	
			else
				contexto.strokeStyle = "#000000";					
			contexto.stroke();
		}
		
		contexto.restore();
	}
}

function dibujar_sobre(){
	if(band_requests.requests.length > 0)
		if(!band_requests.boton.apuntado)
			contexto.drawImage(band_requests.boton.image,band_requests.boton.x,band_requests.boton.y,band_requests.boton.w,band_requests.boton.h);
		else
			contexto.drawImage(band_requests.boton.over_image,band_requests.boton.x,band_requests.boton.y-10,band_requests.boton.w,band_requests.boton.h+10);
	else if(concert_requests.requests.length > 0)
		if(!concert_requests.boton.apuntado)
			contexto.drawImage(concert_requests.boton.image,concert_requests.boton.x,concert_requests.boton.y,concert_requests.boton.w,concert_requests.boton.h);
		else
			contexto.drawImage(concert_requests.boton.over_image,concert_requests.boton.x,concert_requests.boton.y-10,concert_requests.boton.w,concert_requests.boton.h+10);
}

function dibujar_dialogo(){
	if(dialogo.tag!=-1){
		contexto.save();
		
		//Definimos las sombras
		contexto.shadowOffsetX = 5;
		contexto.shadowOffsetY = 5;
		contexto.shadowBlur = 5;
		contexto.shadowColor = '#666';
		
		//Dibujamos el marco
		if(dialogo.alpha<1.0){
			contexto.globalAlpha=dialogo.alpha;
			dialogo.alpha+=FADE_SPEED;
		}
		var gradiente = contexto.createRadialGradient(dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 20, dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 200);
		gradiente.addColorStop(0, "#8ED6FF");
		gradiente.addColorStop(1, "#004CB3");
		contexto.fillStyle = gradiente;
		contexto.beginPath();
		contexto.rect(dialogo.x, dialogo.y, dialogo.w, dialogo.h);
		contexto.closePath();
		contexto.fill();
		
		if(dialogo.tag==TAG_BAND_REQUEST){

			//Dibujamos el mensaje de texto
			contexto.fillStyle = "#000000"; // Color del texto
			contexto.textBaseline = "top"; // Linea base del texto
			contexto.font = "bold 18px Comic Sans"; // Tamano y estilo de la fuente
			contexto.fillText(band_requests.requests[0][0]+" te ha invitado a formar", dialogo.x+10, dialogo.y+10); // Pintamos el texto.
			contexto.fillText("parte de la banda: "+band_requests.requests[0][1]+".", dialogo.x+10, dialogo.y+30); // Pintamos el texto.
			contexto.fillText("Te gustaria formar parte de ella?", dialogo.x+10, dialogo.y+50); // Pintamos el texto.
		
		}else if(dialogo.tag==TAG_CONCERT_REQUEST){

			//Dibujamos el mensaje de texto
			contexto.fillStyle = "#000000"; // Color del texto
			contexto.textBaseline = "top"; // Linea base del texto
			contexto.font = "bold 18px Comic Sans"; // Tamano y estilo de la fuente
			contexto.fillText(concert_requests.requests[0][1]+" te ha invitado a asistir", dialogo.x+10, dialogo.y+10); // Pintamos el texto.
			contexto.fillText("al concierto de su banda: "+concert_requests.requests[0][2]+".", dialogo.x+10, dialogo.y+30); // Pintamos el texto.
			contexto.fillText("Te gustaria asistir?", dialogo.x+10, dialogo.y+50); // Pintamos el texto.			
		}
		
		//Dibujamos las opciones
		var i;
		for(i=0;i<dialogo.coordenadas_opciones.length;i++){
			var gradiente = contexto.createRadialGradient(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 20,
															dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 300);		
			if(i==dialogo.opcion_apuntada){
				gradiente.addColorStop(0, "#F8FFAF");
				gradiente.addColorStop(1, "#6ED500");
			}else{
				gradiente.addColorStop(0, "#D6FF8E");
				gradiente.addColorStop(1, "#4CB300");
			}
			contexto.fillStyle = gradiente;

			contexto.beginPath();
			roundRect(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], dialogo.opcion_w, dialogo.opcion_h, 25);
			
			contexto.fill();
		}
		
		//Dibujamos el texto de las opciones
		contexto.fillStyle = "#000000"; // Color del texto
		contexto.fillText("Aceptar", dialogo.coordenadas_opciones[0][0]+15, dialogo.coordenadas_opciones[0][1]+13);
		contexto.fillText("Rechazar", dialogo.coordenadas_opciones[1][0]+15, dialogo.coordenadas_opciones[1][1]+13);
		
		contexto.restore();
	}
}
